import { Prop, Component, Vue } from 'vue-property-decorator';

function _initializerDefineProperty(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object.keys(descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object.defineProperty(target, property, desc);
    desc = null;
  }

  return desc;
}

var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;
let VueTrackActive = (_dec = Prop({
  type: String,
  default: 'a'
}), _dec2 = Prop({
  type: String,
  default: 'is-active'
}), _dec3 = Prop({
  type: String,
  default: 'top'
}), _dec4 = Prop({
  type: Boolean,
  default: true
}), Component(_class = (_class2 = (_temp = class VueTrackActive extends Vue {
  constructor(...args) {
    super(...args);

    _initializerDefineProperty(this, "linkSelector", _descriptor, this);

    _initializerDefineProperty(this, "activeClass", _descriptor2, this);

    _initializerDefineProperty(this, "trigger", _descriptor3, this);

    _initializerDefineProperty(this, "autoStart", _descriptor4, this);

    this.offset = 0;
    this.links = [];
    this.lastActiveLink = null;
  }

  /**
   *
   */
  get activeClassList() {
    return this.activeClass.split(' ').filter(cl => cl !== '');
  }
  /**
   *
   */


  mounted() {
    window.addEventListener('resize', this.setLinks);
    window.addEventListener('scroll', this.checkLinks);

    if (this.autoStart === true) {
      this.update();
    }
  }
  /**
   *
   */


  beforeDestroy() {
    window.removeEventListener('resize', this.setLinks);
    window.removeEventListener('scroll', this.checkLinks);
  }
  /**
   *
   */


  update() {
    this.setLinks();
    this.checkLinks();
  }
  /**
   *
   */


  checkLinks() {
    if (this.lastActiveLink && this.lastActiveLink.section && this.isInView(this.lastActiveLink.section) === true) {
      return;
    }

    for (const link of this.links) {
      this.activeClassList.forEach(cl => link.menu.classList.remove(cl));
    }

    for (const link of this.links) {
      if (link.section && this.isInView(link.section) === true) {
        this.activeClassList.forEach(cl => link.menu.classList.add(cl));
        break;
      }
    }
  }
  /**
   *
   */


  setLinks() {
    if (this.trigger === 'middle') {
      // is middle
      this.offset = window.innerHeight / 2;
    } else if (this.trigger === 'top') {
      // is top
      this.offset = 0;
    } else if (this.trigger === 'bottom') {
      // is bottom
      this.offset = window.innerHeight;
    } else if (/^\d+(\.\d+)?%$/.test(this.trigger)) {
      // is a percentage
      this.offset = Math.ceil(window.innerHeight * parseFloat(this.trigger) / 100.0);
    } else if (!isNaN(parseFloat(this.trigger))) {
      // is a number
      this.offset = Math.ceil(parseFloat(this.trigger));
    } else {
      this.offset = 0;
    }

    this.links = Array.from(this.$el.querySelectorAll(this.linkSelector)).map(el => ({
      menu: el,
      hash: el.hash,
      section: document.querySelector(el.hash)
    }));
  }
  /**
   *
   */


  isInView(el) {
    const fromTop = window.scrollY;

    if (el.offsetTop <= fromTop + this.offset && el.offsetTop + el.offsetHeight > fromTop + this.offset) {
      return true;
    }

    return false;
  } // /**
  //  *
  //  */
  // private setHash (hash: string): void {
  //   if (hash === null) {
  //     history.pushState({}, document.title, window.location.pathname + window.location.search)
  //   } else if (window.history.replaceState) {
  //     window.history.replaceState({}, null, hash)
  //   } else {
  //     window.location.hash = hash
  //   }
  // }


}, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "linkSelector", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "activeClass", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "trigger", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "autoStart", [_dec4], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

/* script */
const __vue_script__ = VueTrackActive;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', [_vm._t("default")], 2);
};

var __vue_staticRenderFns__ = [];
/* style */

const __vue_inject_styles__ = undefined;
/* scoped */

const __vue_scope_id__ = undefined;
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

// Import vue component

// Default export is installable instance of component.
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),
var entry_esm = /*#__PURE__*/(() => {
  // Assign InstallableComponent type
  const installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = Vue => {
    Vue.component('VueActiveTracker', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export default entry_esm;
